// Generated by CoffeeScript 1.6.3
var Client, assert, request,
  __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

request = require('request');

assert = require('assert');

Client = (function() {
  function Client(host, port, apiKey, secretKey) {
    var options;
    this.host = host;
    this.port = port;
    this.apiKey = apiKey;
    this.secretKey = secretKey;
    this._setArguments = __bind(this._setArguments, this);
    this.applications = __bind(this.applications, this);
    this.users = __bind(this.users, this);
    this.organizations = __bind(this.organizations, this);
    this.datasets = __bind(this.datasets, this);
    this.path = __bind(this.path, this);
    if (host instanceof Object) {
      options = this.host;
      this.host = options.host || 'api.openify.it';
      this.port = options.port || 80;
      this.apiKey = options.apiKey;
      this.secretKey = options.secretKey;
    }
    assert(this.host);
    assert(this.port);
    assert(this.apiKey);
    assert(this.secretKey);
    this.request = request;
  }

  Client.prototype.path = function(method, path, options, callback) {
    if (options instanceof Function) {
      callback = options;
      options = {};
    }
    if (options.qs == null) {
      options.qs = {};
    }
    options.qs.apiKey = this.apiKey;
    options.qs.secretKey = this.secretKey;
    options.url = "http://" + this.host + ":" + this.port + path;
    options.method = method;
    if (options.headers == null) {
      options.headers = {};
    }
    options.headers.host = this.host;
    return this.request(options, callback);
  };

  Client.prototype.datasets = function(id, options, callback) {
    var path, _ref;
    _ref = this._setArguments(id, options, callback), id = _ref[0], options = _ref[1], callback = _ref[2];
    path = id ? "/datasets/" + id : '/datasets';
    return this.path('GET', path, options, callback);
  };

  Client.prototype.organizations = function(id, options, callback) {
    var path, _ref;
    _ref = this._setArguments(id, options, callback), id = _ref[0], options = _ref[1], callback = _ref[2];
    path = id ? "/organizations/" + id : '/organizations';
    return this.path('GET', path, options, callback);
  };

  Client.prototype.users = function(id, options, callback) {
    var path, _ref;
    _ref = this._setArguments(id, options, callback), id = _ref[0], options = _ref[1], callback = _ref[2];
    path = id ? "/users/" + id : '/users';
    return this.path('GET', path, options, callback);
  };

  Client.prototype.applications = function(id, options, callback) {
    var path, _ref;
    _ref = this._setArguments(id, options, callback), id = _ref[0], options = _ref[1], callback = _ref[2];
    path = id ? "/applications/" + id : '/applications';
    return this.path('GET', path, options, callback);
  };

  Client.prototype._setArguments = function(id, options, callback) {
    if (id instanceof Function) {
      callback = id;
      id = null;
      options = {};
    } else if (id instanceof Object && options instanceof Function) {
      callback = options;
      options = id;
      id = null;
    } else if (id instanceof String && options instanceof Function) {
      callback = options;
      options = {};
    }
    return [id, options, callback];
  };

  return Client;

})();

module.exports = Client;
