request = require 'request'
assert = require 'assert'

class Client
    constructor: (@host, @port, @apiKey, @secretKey) ->
        if host instanceof Object
            options = @host
            @host = options.host || 'api.openify.it'
            @port = options.port || 80
            @apiKey = options.apiKey
            @secretKey = options.secretKey

        assert @host
        assert @port
        assert @apiKey
        assert @secretKey

        #TODO find a way to spyOnModule
        @request = request

    path: (method, path, options, callback) =>
        if options instanceof Function
            callback = options
            options = {}
        options.qs ?= {}
        options.qs.apiKey = @apiKey
        options.qs.secretKey = @secretKey

        options.url = "http://#{@host}:#{@port}#{path}"
        options.method = method

        options.headers ?= {}
        options.headers.host = @host

        @request options, callback

    datasets: (id, options, callback) =>
        [id, options, callback] = @_setArguments id, options, callback

        path = if id then "/datasets/#{id}" else '/datasets'
        @path 'GET', path, options, callback

    organizations: (id, options, callback) =>
        [id, options, callback] = @_setArguments id, options, callback
        path = if id then "/organizations/#{id}" else '/organizations'
        @path 'GET', path, options, callback

    users: (id, options, callback) =>
        [id, options, callback] = @_setArguments id, options, callback
        path = if id then "/users/#{id}" else '/users'
        @path 'GET', path, options, callback

    applications: (id, options, callback) =>
        [id, options, callback] = @_setArguments id, options, callback
        path = if id then "/applications/#{id}" else '/applications'
        @path 'GET', path, options, callback

    _setArguments: (id, options, callback) =>
        if id instanceof Function
            callback = id
            id = null
            options = {}
        else if id instanceof Object and options instanceof Function
            callback = options
            options = id
            id = null
        else if id instanceof String and options instanceof Function
            callback = options
            options = {}

        return [id, options, callback]



module.exports = Client
